# More about the network

Each node in the network runs inside an enclave. The enclave is a program that operates
in a trusted execution environment (TEE). Memory of programs within the enclave can
not be inspected from outside the enclave. Programs within the enclave have access
to sources of entropy that cannot be predicted from outside. Programs can also access
reproducible secrets that they can use to seal[^1] persistent data. Each enclave has
a certain set of measurements, consisting of all the data required for the program to
run (instructions, configuration, etc.). A running program can generate a quote that
can be used to verify the measurements and legitimacy of the hardware it's running on.

Assuming there are no vulnerabilities in any of the mentioned hardware features, and
our node implementation has none either, it should be practically impossible to steal
the SOL from the network wallet because:
- wallet key is generated with the enclave's source of entropy
- nobody can inspect the memory that contains the key
- nodes verify the quote of each peer and refuse connections if quote measurements
  don't match their own
- node seals[^1] all persistent data saved to disk with the enclave's key

[^1]: uses symmetric encryption to encrypt some data before exposing it to untrusted
environment to later recover the data by decrypting.
